/*
 * Trading Platform "Bellagio"
 * Copyright (c) 2006, 2007  Lagarto Technology, Inc.
 * 
 * $Id$
 * $DateTime$
 * 
 * tH[̂A{̂UI𔲂oUserControl
 * ɓRg[镪Ă\
 */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Resources;
using System.Diagnostics;

using Travis;
using Travis.LocationOperation;
using Poderosa;

using Bellagio.Common;
using Bellagio.Data;
using Bellagio.Forms;
using Bellagio.Chart;
using Bellagio.Environment;
using Bellagio.Values;
using Bellagio.Drawing;

using Poderosa.Sessions;
using Poderosa.Forms;
using Poderosa.Commands;

namespace Bellagio.Ordering {
    public class OrderControl : UserControl {

        public interface IOrderControlHost {
            Stock CurrentStockForOrder { get; }
            AbstractStockProfile CurrentStockProfile { get; }
        }

        private OrderFormParameter _parameter;
        private IOrderControlHost _host;

        private Font _orderMainFont; //̂dvڂ͑傫tHg
        private Font _UINumericFont; //wlEʓ̓tHg
        private Font _figureFont;    //|WV̕\ŐɎgptHg
        private int _figureFontYOffset; //ʒu킹
        private Brush _figureBrush;
        private Brush _buyMarkBrush;  //Ẽ|WV/ɂ킹ĕ\
        private Brush _sellMarkBrush;
        private Color _backColor;
        private Color _foreColor;

        private int _additionalPanelHeight; //ċʎw肪Ƃǉׂ
        
        //擾ς݌l,]͏@擾̂Ƃnull
        private OrderDataStockSnapshot _stockSnapshot;
        private StockBuyingPowerInfo _stockPowerInfo;
        private DerivativeBuyingPowerInfo _derivativePowerInfo;

        //Siځ@敪 (ρEł̓|WVe܂͒e\)
        //̎wQZbg
        private Label _orderTypeLabel;
        private Label _baibaiLabel;

        //B. ExEI{/{VK/ԍ
        private RibbonMenuButton _dealTypeGenbutsu;
        private RibbonMenuButton _dealTypeSeido;
        private RibbonMenuButton _dealTypeIppan;
        private RibbonMenuButton _buyButton;
        private RibbonMenuButton _sellButton;
        private RibbonMenuButton _newPositionButton;
        private RibbonMenuButton _closePositionButton;

        //C. |WV܂ĂƂ
        private Control _currentPositionOrOrder; //ϒ(P|W)EύX̂Ƃ͂ɂ̒Ƀ|WVEeo
        private DataGridView _positionDetailList;    //ϒ(|W)̂Ƃ͂̃Xgr[Œڍׂ
        private bool _positionDetailListVisible; //tH[̂\̂ƂAVisiblevpeBƂ˂FalseɂȂĂ܂I
        private Label _separator2;

        //Tiځ@i
        private Label _sashineLabel;
        private VolumeInputBox _sashineBox;
        private HoveringLabel _sashineDec10;
        private HoveringLabel _sashineDec;
        private HoveringLabel _sashineInc;
        private HoveringLabel _sashineInc10;
        private CheckBox _nariyukiButton;
        private HoveringLabel _priceInfoIcon; //lE]͂ȂǕ\̃c[`bv
        private struct PriceInfoTexts {
            public string priceRangeText;
            public string tradeAmountText;
        }
        private PriceInfoTexts _priceInfoTexts;

        //Uiځ@
        private Label _volumeLabel;
        private VolumeInputBox _volumeBox;
        private HoveringLabel _volumeDec10;
        private HoveringLabel _volumeDec;
        private HoveringLabel _volumeInc;
        private HoveringLabel _volumeInc10;
        //private Button _maxVolumeButton; //S̓{^
        private Label _separator3;

        //Viځ@sAi/ʁj
        private Label _sikkoLabel;
        private ComboBox _sikkoBox;
        private Label _kouzaLabel;
        private ComboBox _kouzaBox;

        //Wiځ@AmFʕ\
        private Label _dateLabel;
        private ComboBox _dateBox;
        private CheckBox _omitConfirmDialogBox;

        //Xiځ@ÏؔԍƏȗIvV
        private Label _pinCodeLabel;
        private TextBox _pinCodeBox;
        private CheckBox _savePinCodeBox;
        private Label _separator4;

        //zu
        private RectOp _regularMainRectOp;         //gbvx(ʏ)
        private RectOp _gridMainRectOp;          //gbvx(ԍς̏ڍׂ̃Obhgp)
        
        //private BRect _codeBoxRect;              //Ȃǂ̃{^A
        //private RectangleOperator _codeBoxRectOp;
        private BRect _positionOrDealTypeRect;          //ʁÃ݂|WVAêꂩ
        private RectOp _positionOrDealTypeRectOp;
        private BRect _priceAndVolumeRect;              //iEʂȂǂ̓͗̈
        private RectOp _priceAndVolumeRectOp;

        //UIŒeύXɂȂꍇɏoCxg vpeBZbgł͏oȂ
        public event VoidVoidDelegate OrderContentChanged;
        public event VoidVoidDelegate OmitOrderConfirmChanged;
        public delegate void StockChangedDelegate(AbstractStockProfile prof);
        
        public OrderControl(IOrderControlHost host) {
            _host = host;

            _backColor = Color.Black;
            _foreColor = Color.White;
            this.BorderStyle = BorderStyle.None;
            IconList common_icon = BellagioRoot.CommonIcons.SmallCommandButtons;

            _orderMainFont = new Font("lr SVbN", 9F);
            _UINumericFont = new Font("lr SVbN", 10.5F);
            _figureFont = new Font("lr SVbN", 9F);
            _figureBrush = new SolidBrush(Color.DarkGoldenrod);
            _figureFontYOffset = 0;
            _buyMarkBrush = new SolidBrush(Color.Red);
            _sellMarkBrush = new SolidBrush(Color.DarkBlue);

            //_codeBoxRect = new BRect();
            _positionOrDealTypeRect = new BRect();
            _priceAndVolumeRect = new BRect();
            _orderTypeLabel = FormUtil.CreateLabel("");
            _orderTypeLabel.TextAlign = ContentAlignment.TopLeft; //Ƀ|WV邱Ƃ
            _baibaiLabel = FormUtil.CreateLabel("");
            _baibaiLabel.TextAlign = ContentAlignment.TopLeft;
            _dealTypeGenbutsu = CreateTextOnlyRibbon("", new MouseEventHandler(OnDealTypeCheckedChanged));
            _dealTypeSeido = CreateTextOnlyRibbon("x", new MouseEventHandler(OnDealTypeCheckedChanged));
            _dealTypeIppan = CreateTextOnlyRibbon("", new MouseEventHandler(OnDealTypeCheckedChanged));
            _buyButton = CreateBuyOrSellButton("", 7);
            _sellButton = CreateBuyOrSellButton("", 8);
            _newPositionButton = CreateTextOnlyRibbon("VK", new MouseEventHandler(OnNewOrCloseCheckedChanged));
            _closePositionButton = CreateTextOnlyRibbon("ԍ", new MouseEventHandler(OnNewOrCloseCheckedChanged));
            //_dealTypeGenbutsu.AutoCheck = _dealTypeSeido.AutoCheck = _dealTypeIppan.AutoCheck = _newPositionButton.AutoCheck = _closePositionButton.AutoCheck = false;

            _currentPositionOrOrder = FormUtil.CreateCustomPaintControl(new PaintEventHandler(OnPaintCurrentPositionOrOrder));
            _currentPositionOrOrder.Resize += new EventHandler(OnResizeCurrentPositionOrOrder);
            _currentPositionOrOrder.Font = _orderMainFont;
            _positionDetailList = CreatePositionDetailListView();
            _separator2 = FormUtil.CreateSeparatorAsLabel();
            _sashineLabel = CreateLabelVM("wl(&P)");
            _sashineBox = new VolumeInputBox();
            _sashineBox.Font = _UINumericFont;
            _sashineDec10 = CreateSashineChangeLabel(3);
            _sashineDec = CreateSashineChangeLabel(5);
            _sashineInc = CreateSashineChangeLabel(6);
            _sashineInc10 = CreateSashineChangeLabel(4);
            _nariyukiButton = FormUtil.CreateImageAndTextToggleButton(null, "s", new EventHandler(OnNariyukiButtonClick));
            _nariyukiButton.ImageAlign = ContentAlignment.MiddleLeft;
            _priceInfoIcon = new HoveringLabel(common_icon.GetBitmap(1), common_icon.GetBitmap(2));
            this.MouseMove += new MouseEventHandler(OnMouseMoveForPriceInfoIcon);
            _priceInfoIcon.MouseMove += new MouseEventHandler(OnMouseMoveForPriceInfoIcon);
            //_priceInfoIcon.MouseEnter += new EventHandler(OnPriceInfoMouseEnter);
            //_priceInfoIcon.MouseLeave += new EventHandler(OnPriceInfoMouseLeave);
            //_currentPriceButton = CreateTextCommandButton("<<l", new EventHandler(OnCurrentPriceButtonClick));
            _volumeLabel = CreateLabelVM("(&V)");
            _volumeBox = new VolumeInputBox();
            _volumeBox.Font = _UINumericFont;
            _volumeDec10 = CreateVolumeChangeLabel(3);
            _volumeDec = CreateVolumeChangeLabel(5);
            _volumeInc = CreateVolumeChangeLabel(6);
            _volumeInc10 = CreateVolumeChangeLabel(4);
            //_maxVolumeButton = CreateTextCommandButton("S", new EventHandler(OnMaxVolumeButtonClick));
            _separator3 = FormUtil.CreateSeparatorAsLabel();
            EventHandler misc_cond_change = delegate(object sender, EventArgs args) { this.OrderContentChanged(); };
            _sikkoBox = CreateComboBox("Ȃ", "t", "", "w"); //̍\͉ς̂ق
            _sikkoBox.SelectedIndexChanged += misc_cond_change;
            _sikkoLabel = CreateLabelVM("s敪(&E)");
            _kouzaLabel = CreateLabelVM("(&Z)");
            _kouzaBox = CreateComboBox();
            _kouzaBox.SelectedIndexChanged += misc_cond_change;
            _dateLabel = CreateLabelVM("L(&D)");
            _dateBox = CreateComboBox("", "T");
            _dateBox.SelectedIndexChanged += misc_cond_change;
            _omitConfirmDialogBox = new CheckBox();
            _omitConfirmDialogBox.Text = "mFʏȗ(&R)";
            _omitConfirmDialogBox.CheckedChanged += delegate(object sender, EventArgs args) { //mFʂȗƁApincodeL͋
                _savePinCodeBox.Checked = true;
                _savePinCodeBox.Enabled = !_omitConfirmDialogBox.Checked;
                if(this.OmitOrderConfirmChanged!=null) this.OmitOrderConfirmChanged();
            };
            _pinCodeLabel = CreateLabelVM("Ï(&N)");
            _pinCodeBox = new TextBox();
            _pinCodeBox.PasswordChar = '*';
            _savePinCodeBox = new CheckBox();
            _savePinCodeBox.Text = "Ï؋L(&S)";
            _separator4 = FormUtil.CreateSeparatorAsLabel();

            this.Controls.AddRange(new Control[] {
            _orderTypeLabel, _baibaiLabel, _dealTypeGenbutsu, _dealTypeSeido, _dealTypeIppan, _buyButton, _sellButton, _newPositionButton, _closePositionButton, _currentPositionOrOrder, _positionDetailList, _separator2,
            _volumeLabel, _volumeBox,  _volumeInc10, _volumeInc, _volumeDec, _volumeDec10, 
            _sashineLabel, _sashineBox, _sashineInc10, _sashineInc, _sashineDec, _sashineDec10,  _nariyukiButton, _priceInfoIcon,
             _separator3,
            _sikkoLabel, _sikkoBox, _kouzaLabel, _kouzaBox,
            _dateLabel, _dateBox, _omitConfirmDialogBox,
            _pinCodeLabel, _pinCodeBox, _savePinCodeBox,
            });

            int row_s = 24; //P̍()
            int lh = 19; //x
            int row_m = 30; //P̍()
            int m = 8; //W̃Rg[ԃ}[W
            int ll = 4; //̃xp[gXW
            int lw = 80; //̃xp[g̕
            int lc = lw-4; //̃x̃Rg[̕
            int cw = 80; //iEʂȂǂ̃Rg[
            int sb = 20; //ACRRg[̈
            int rib_w = 52; //摜t{̃TCY
            int rib_h = 48;

            _sashineBox.Height = row_m-4;
            _volumeBox.Height = row_m-4;
      

            _priceAndVolumeRectOp = new RectangleOperatorBuilder(0)
                .SplitTop(8)
                    .Shrink(3).ProbeControl(_separator2).CloseBranch()
                .SplitTop(row_s)
                    .SplitFixed(SplitDir.Left, lw).PlaceControl(ContentAlignment.MiddleLeft, _volumeLabel, lc, row_s).CloseBranch()
                    .PlaceControl(ContentAlignment.TopLeft, _volumeBox, cw, row_s)
                    .VCenter(sb)
                    .RightControlMM(_volumeInc10, 2)
                    .RightControl(_volumeInc).RightControl(_volumeDec).RightControl(_volumeDec10)
                    .CloseBranch()
                .SplitTop(row_s)
                    .SplitFixed(SplitDir.Left, lw).PlaceControl(ContentAlignment.MiddleLeft, _sashineLabel, lc, row_s).CloseBranch()
                    .PlaceControl(ContentAlignment.TopLeft, _sashineBox, cw, row_s)
                    .VCenter(sb)
                    .RightControlMM(_sashineInc10, 2)
                    .RightControl(_sashineInc).RightControl(_sashineDec).RightControl(_sashineDec10)
                    .CloseBranch()
                .SplitTop(row_s)
                    .CornerOffset(RectCorner.TopLeft, lw, 0, 64, row_s).ProbeControl(_nariyukiButton)
                    .CornerOffset(RectCorner.TopRight, 8, 2, 16, 16).ProbeControl(_priceInfoIcon)
                    .CloseBranch()
                .SplitFixed(SplitDir.Top, 8)
                    .Shrink(3).ProbeControl(_separator3)
                    .CloseBranch()
                .SplitFixed(SplitDir.Top, row_s)
                    .SplitRatio(SplitDir.Left, 0.6F, 64)
                        .SplitFixed(SplitDir.Left, lw).CornerOffset(RectCorner.TopLeft, ll, 0, lc, lh).ProbeControl(_sikkoLabel).CloseBranch()
                        .PlaceControl(ContentAlignment.TopLeft, _sikkoBox, cw, row_s)
                        .CloseBranch()
                    .SplitFixed(SplitDir.Left, 44).CornerOffset(RectCorner.TopLeft, 0, 0, 52, lh).ProbeControl(_kouzaLabel)
                        .RightControl(_kouzaBox, 52, row_s).CloseBranch()
                    .CloseBranch()
                .SplitFixed(SplitDir.Top, row_s)
                    .SplitRatio(SplitDir.Left, 0.6F, 64)
                        .SplitFixed(SplitDir.Left, lw).CornerOffset(RectCorner.TopLeft, ll, 0, lc, lh).ProbeControl(_dateLabel).CloseBranch()
                        .PlaceControl(ContentAlignment.TopLeft, _dateBox, cw, row_s)
                        .CloseBranch()
                    .ProbeControl(_omitConfirmDialogBox)
                    .CloseBranch()
                .SplitFixed(SplitDir.Top, row_s)
                    .SplitRatio(SplitDir.Left, 0.6F, 64)
                        .SplitFixed(SplitDir.Left, lw).CornerOffset(RectCorner.TopLeft, ll, 0, lc, lh).ProbeControl(_pinCodeLabel).CloseBranch()
                        .PlaceControl(ContentAlignment.TopLeft, _pinCodeBox, cw, row_s)
                        .CloseBranch()
                        .ProbeControl(_savePinCodeBox)
                    .CloseBranch()
                .SplitFixed(SplitDir.Top, 8)
                    .Shrink(3).ProbeControl(_separator4).CloseBranch()
                .Finish();

            //ObhRg[_currentPositionOrOrder̃TCYɒǐ`Ŏ蓮œ
            _positionOrDealTypeRectOp = new RectangleOperatorBuilder(0)
                .SplitFixed(SplitDir.Left, lw)
                    .CornerOffset(RectCorner.TopLeft, ll, 0, lc, row_s).ProbeControl(_orderTypeLabel)
                    .CornerOffset(RectCorner.TopLeft, 0, 28, lc, row_s).ProbeControl(_baibaiLabel)
                    .CloseBranch()
                .Tee().ProbeControl(_currentPositionOrOrder).CloseBranch()
                .SplitFixed(SplitDir.Top, 28)
                    .PlaceControl(ContentAlignment.TopLeft, _dealTypeGenbutsu, rib_w, row_s)
                    .RightControlMM(_dealTypeSeido, 2, rib_w, row_s)
                    .RightControlMM(_dealTypeIppan, 2, rib_w, row_s)
                    .CloseBranch()
                .PlaceControl(ContentAlignment.TopLeft, _buyButton, rib_w, rib_h)
                .RightControlMM(_sellButton, 2, rib_w, rib_h)
                .CornerOffset(RectCorner.TopRight, m, 0, rib_w, row_s).ProbeControl(_newPositionButton)
                .CornerOffset(RectCorner.BottomLeft, 0, rib_h-row_s*2, rib_w, row_s).ProbeControl(_closePositionButton)
                .Finish();

            //[gRectOṕAԍώƒʏňقȂ̂QޗpӂĂ
            const int positionOrDealTypeH = 80;
            const int priceAndVolumeH = 160;
            
            RectangleOperatorBuilder bld = new RectangleOperatorBuilder();
            bld.SplitFixed(SplitDir.Top, positionOrDealTypeH).ProbeBRect(_positionOrDealTypeRect).CloseBranch();
            bld.SplitFixed(SplitDir.Top, priceAndVolumeH).ProbeBRect(_priceAndVolumeRect).CloseBranch();
            _regularMainRectOp = bld.Finish();

            bld = new RectangleOperatorBuilder();
            bld.SplitFixed(SplitDir.Bottom, priceAndVolumeH).ProbeBRect(_priceAndVolumeRect).CloseBranch();
            bld.ProbeBRect(_positionOrDealTypeRect);
            _gridMainRectOp = bld.Finish();
            
            this.BackColor = _backColor;
            this.BackColor = SystemColors.Control;
            _sashineBox.BackColor = _backColor; _sashineBox.ForeColor = _foreColor;
            _sashineBox.MouseWheel += new MouseEventHandler(OnMouseWheelSashine);
            _sashineBox.UnitChangeHandler = delegate(bool increment) {
                ChangeSashine(increment, false);
                this.OrderContentChanged();
            };
            _sashineBox.TextAlign = HorizontalAlignment.Right;
            _sashineBox.ValueChangeByKey = delegate(int newvalue) {
                AdjustTradeAmountLabel();
                this.OrderContentChanged();
            };
            _volumeBox.BackColor = _backColor; _volumeBox.ForeColor = _foreColor;
            _volumeBox.MouseWheel += new MouseEventHandler(OnMouseWheelVolume);
            _volumeBox.UnitChangeHandler = delegate(bool increment) {
                ChangeVolume(increment, false);
                this.OrderContentChanged();
            };
            _volumeBox.ValueChangeByKey = delegate(int newvalue) {
                AdjustTradeAmountLabel(); AdjustVolumeInGrid(newvalue);
                this.OrderContentChanged();
            };
            _pinCodeBox.BackColor = _backColor; _pinCodeBox.ForeColor = _foreColor;
            _pinCodeBox.MaxLength = BRuntimeOpts.MAX_PASSWORD_LENGTH;

            BellagioRoot.OrderDataProvider.StockBuyingPowerInfo.AddListener(new DataThreadToMainThread(ReceiveStockBuyingPowerInfo));
            BellagioRoot.OrderDataProvider.DerivativeBuyingPowerInfo.AddListener(new DataThreadToMainThread(ReceiveDerivativeBuyingPowerInfo));
        }

        public int AdditionalPanelHeight {
            get {
                return _additionalPanelHeight;
            }
        }
        public bool IsGridVisible {
            get {
                return _positionDetailListVisible;
            }
        }
        public bool OmitConfirmDialogBox {
            get {
                return _omitConfirmDialogBox.Checked;
            }
        }
        private Label CreateLabelVT(string text) {
            Label l = FormUtil.CreateLabelVT(text);
            l.Font = this.Font;
            l.ForeColor = this.ForeColor;
            l.BackColor = this.BackColor;
            return l;
        }
        private Label CreateLabelVM(string text) {
            Label l = FormUtil.CreateLabel(text);
            l.Font = this.Font;
            l.ForeColor = this.ForeColor;
            l.BackColor = this.BackColor;
            return l;
        }
        protected override void Dispose(bool disposing) {
            base.Dispose(disposing);
            if(disposing) {
                if(_priceInfoToolTip!=null) _priceInfoToolTip.Dispose();
            }
        }
        /*
        private RibbonMenuButton CreateOrderTypeButton(string text, int image_index) {
            RibbonMenuButton b = FormUtil.CreateRibbonMenuButton(text, LargeBitmap(image_index), new MouseEventHandler(OnOrderTypeButtonClick));
            b.Checked = false;
            b.TextAlign = ContentAlignment.BottomCenter;
            return b;
        }
        */
        private RibbonMenuButton CreateBuyOrSellButton(string text, int image_index) {
            RibbonMenuButton b = FormUtil.CreateRibbonMenuButton(text, LargeBitmap(image_index), new MouseEventHandler(OnBuyOrSellButtonClick));
            b.Checked = false;
            b.TextAlign = ContentAlignment.BottomCenter;
            return b;
        }
        private RibbonMenuButton CreateTextOnlyRibbon(string text, MouseEventHandler click) {
            RibbonMenuButton b = FormUtil.CreateRibbonMenuButton(text, null, click);
            b.Checked = false;
            b.TextAlign = ContentAlignment.MiddleCenter;
            return b;
        }
        private HoveringLabel CreateVolumeChangeLabel(int image_index) {
            IconList il = BellagioRoot.CommonIcons.ControlBoxes;
            HoveringLabel l = new HoveringLabel(il.GetBitmap(0, image_index), il.GetBitmap(1, image_index));
            l.MouseDown += new MouseEventHandler(OnVolumeChangeButtonClick);
            return l;
        }
        private HoveringLabel CreateSashineChangeLabel(int image_index) {
            IconList il = BellagioRoot.CommonIcons.ControlBoxes;
            HoveringLabel l = new HoveringLabel(il.GetBitmap(0, image_index), il.GetBitmap(1, image_index));
            l.MouseDown += new MouseEventHandler(OnSashineChangeButtonClick);
            return l;
        }
        private ComboBox CreateComboBox(params string[] items) {
            ComboBox cb = FormUtil.CreateComboBox(items);
            cb.BackColor = _backColor;
            cb.ForeColor = _foreColor;
            return cb;
        }
        private Button CreateTextCommandButton(string text, EventHandler click) {
            Button b = new Button();
            b.Text = text;
            b.FlatStyle = FlatStyle.System;
            b.Click += click;
            b.Enabled = false;
            return b;
        }

        //L[{[hnh
        protected override bool ProcessDialogKey(Keys k) {
            //Debug.WriteLine(keyData.ToString());
            //֗ȃV[gJbgL[𑕔
            if(!_pinCodeBox.Focused) { //At@xbgn̓R[h́EÏ؂̓͒
                if(k==Keys.P && _sashineBox.Enabled) _sashineBox.Focus();
                else if(k==Keys.V && _volumeBox.Enabled) _volumeBox.Focus();
                else if(k==Keys.Q && _dealTypeGenbutsu.Enabled) OnDealTypeCheckedChanged(_dealTypeGenbutsu, null);
                else if(k==Keys.M && _dealTypeSeido.Enabled) OnDealTypeCheckedChanged(_dealTypeSeido, null);
                else if(k==(Keys.M|Keys.Shift) && _dealTypeIppan.Enabled) OnDealTypeCheckedChanged(_dealTypeIppan, null);
                else if(k==Keys.B && _buyButton.Enabled) OnBuyOrSellButtonClick(_buyButton, null);
                else if(k==Keys.S && _sellButton.Enabled) OnBuyOrSellButtonClick(_sellButton, null);
                else if(k==Keys.N && _newPositionButton.Enabled) OnNewOrCloseCheckedChanged(_newPositionButton, null);
                else if(k==Keys.C && _closePositionButton.Enabled) OnNewOrCloseCheckedChanged(_closePositionButton, null);
            }
            /*
            if(k==Keys.F2 && _codeBox.EnabledEx) _codeBox.SelectAllEx();
            if(k==Keys.F3 && _creditTypeBox.Enabled) ToggleCreditTypeBox();
            if(k==Keys.F4 && _nariyukiButton.Enabled) OnNariyukiButtonClick(_nariyukiButton, null);
            if(k==Keys.F5 && _currentPriceButton.Enabled) OnCurrentPriceButtonClick(_currentPriceButton, null);
            */
            //if(k==Keys.F10 && _maxVolumeButton.Enabled) OnMaxVolumeButtonClick(_maxVolumeButton, null);
            if(k==Keys.Add && _sashineBox.Enabled) ChangeSashine(true, false);
            if(k==Keys.Subtract && _sashineBox.Enabled) ChangeSashine(false, false);

            //Escape/Enter̈Ԃ
            if(k==Keys.Escape && _positionDetailList.Focused) {
                return true;
            }
            if(k==Keys.Enter && (_positionDetailList.EditingControl!=null)) {
                return true;
            }
            return base.ProcessDialogKey(k);
        }

        public CommandResult InitContent(OrderFormParameter info) {
            Debug.Assert(this.OrderContentChanged!=null); //Cxgnho^ĂȂƂɂ̂łĂԂ܂ɐݒ
            bool detail_grid_available = false; //ڍו\ObhLǂ

            try {
                _parameter = info;
                IOrderItemFormatter formatter = BellagioRoot.OrderDataProvider.OrderItemFormatter;

                AbstractStockProfile prof = info.StockProfile;
                SetCurrentStock(prof==null? null : prof.Primary);
                _pinCodeBox.Text = (BellagioRoot.FixedPreferences.AutoPinCode && BellagioRoot.FixedPreferences.PinCodeVerified)? BellagioRoot.FixedPreferences.SavedPinCode : "";
                _savePinCodeBox.Checked = BellagioRoot.FixedPreferences.AutoPinCode;
                _omitConfirmDialogBox.Checked = !BellagioRoot.FixedPreferences.Ordering.ShowOrderConfirmDialog;

                //ԍρEł͐ݒ\ڂI
                if(_parameter.OrderCategory==OrderFormParameter.Category.NewPosition) {
                    TradeOrderItem item = _parameter.CurrentOrder; //ۗ𕜊Ă邱Ƃ邽
                    bool plane = item==null;
                    bool credit_account = BellagioRoot.OrderDataProvider.AccountInfo.CreditAccountEnabled;
                    _currentPositionOrOrder.Visible = false;
                    _positionDetailList.Visible = false;
                    _baibaiLabel.Visible = true;
                    if(!plane) {
                        _dealTypeGenbutsu.Checked = item.DealType==OrderDealType.Genbutsu || item.DealType==OrderDealType.Derivatives;
                        _dealTypeSeido.Checked = item.DealType==OrderDealType.CreditSeido;
                        _dealTypeIppan.Checked = item.DealType==OrderDealType.CreditIppan;
                        _buyButton.Checked = item.IsBuying;
                        _sellButton.Checked = !item.IsBuying;
                        _newPositionButton.Enabled = item.DealType!=OrderDealType.Genbutsu;
                        _closePositionButton.Enabled = item.DealType!=OrderDealType.Genbutsu;
                        _newPositionButton.Checked = item.DealType!=OrderDealType.Genbutsu && item.NewOrClose==OrderNewClose.New;
                        _closePositionButton.Checked = item.DealType!=OrderDealType.Genbutsu && item.NewOrClose==OrderNewClose.Close;
                    }
                    SetSashineBoxEnabled(plane? true : OrderingUtil.IsSashineRequired(item.Condition));
                    _sashineBox.SetTextByInt(plane? (prof==null? 1 : GetInitialSashinePrice(prof.Primary)) : item.AdjustPriceI(item.Sashine));
                    _nariyukiButton.Enabled = true;
                    _volumeBox.Enabled = true;
                    _volumeBox.SetTextByInt(plane? (prof==null? 0 : prof.Primary.VolumeUnit) : item.Volume);
                    _volumeBox.MaximumValue = 100000000;
                    _volumeBox.ZeroFixedDigits = prof==null? 0 : GetZeroDigitsCountFromVolumeUnit(prof.Primary.VolumeUnit);
                    //_maxVolumeButton.Visible = true;
                    //_maxVolumeButton.Enabled = false;
                    _sikkoBox.Enabled = true;
                    _sikkoBox.SelectedIndex = plane? 0 : GetSikkoBoxSelectedIndexFromOrderCondition(item.Condition);
                    AdjustKouzaBox(true);
                    _dateBox.SelectedIndex = plane? 0 : (item.LimitDate==OrderLimitDate.Today? 0 : 1); //TODO l͌ŒIȂق
                    _dateBox.Enabled = true;
                    //]͏XV ł敨
                    BellagioRoot.OrderDataProvider.StockBuyingPowerInfo.Refresh();
                }
                else { //܂͌
                    Debug.Assert(prof!=null);
                  
                    bool change = _parameter.OrderCategory==OrderFormParameter.Category.Change; //or
                    bool close = !change;
                    TradeOrderItem order = _parameter.CurrentOrder;
                    TradePositionItem position = _parameter.CurrentPosition;
                    //UIȗ郂[hłMarketButton͎gȂACreateTradeOrderItemUIłmarketButton.SelectedIndexg
                    _currentPositionOrOrder.Visible = true;
                    if(_parameter.CloseType==OrderFormParameter.ClosePositionType.MultiplePosition) {
                        detail_grid_available = true;
                        InitPositionDetailListContent(order);
                    }
                    _orderTypeLabel.Text = close? "|WV" : "";
                    _baibaiLabel.Visible = false;
                    _dealTypeGenbutsu.Visible = _dealTypeSeido.Visible = _dealTypeIppan.Visible = _buyButton.Visible = _sellButton.Visible = _newPositionButton.Visible = _closePositionButton.Visible = false;
                    //if(change)
                    //    GetOrderTypeButton(order.DealType, order.LongShort).Checked = true;
                    _volumeBox.Enabled = !change; //ł͕ύXs
                    int max_volume = change? order.Volume : _parameter.MaximumVolume;
                    _volumeBox.MaximumValue = max_volume;
                    int volume = order!=null? order.Volume : max_volume;
                    _volumeBox.SetTextByInt(volume);
                    _volumeBox.ZeroFixedDigits = GetZeroDigitsCountFromVolumeUnit(prof.Primary.VolumeUnit);
                    _sikkoBox.Enabled = close;
                    _sikkoBox.SelectedIndex = order==null? 0 : GetSikkoBoxSelectedIndexFromOrderCondition(order.Condition);
                    SetSashineBoxEnabled(order==null? true : OrderingUtil.IsSashineRequired(order.Condition));
                    _sashineBox.SetTextByInt(order==null? GetInitialSashinePrice(prof.Primary) : order.AdjustPriceI(order.Sashine));
                    _nariyukiButton.Enabled = true;
                    _nariyukiButton.Checked = !_sashineBox.Enabled;
                    //_powerAmountText.Visible = false;
                    //_maxVolumeButton.Visible = false; //S̓{^͐VK̂
                    _dateBox.Enabled = close;
                    _dateBox.SelectedIndex = order==null? 0 : (order.LimitDate==OrderLimitDate.Today? 0 : 1);
                    AdjustKouzaBox(true);
                    //lɂ̂͂̃\bh`CodeBoxoRSetCurrentStockĂ΂̂łł͕sv
                }

                //ʕ\[hŁAs\Ȃ玩̍𑝂
                _positionDetailList.Visible = _positionDetailListVisible = detail_grid_available;
                ResizeOrderPanel(detail_grid_available); //tH[̒g_ŃTCY@̂ƂɃ{^ςɓ\邪

                
                if(detail_grid_available) {
                    _additionalPanelHeight = 48;
                    /*
                    OnResizeCurrentPositionOrOrder(null, null); //蓮ŌĂԁB_positionDetailList̃TCYݒ肳
                    int h =  48 - _positionDetailList.Height; //48n[hR[fBOȂ̂炵
                    if(h > 0) {
                        _additionalPanelHeight = h;
                        ResizeOrderPanel(detail_grid_available); //Ŝ̃TCYς̂łx
                    }
                    else
                        _additionalPanelHeight = 0;
                    */
                }

                return CommandResult.Succeeded;
            }
            catch(Exception ex) {
                RuntimeUtil.ReportException(ex);
                return CommandResult.Failed;
            }
        }
        private Stock GetCurrentStock() {
            return _host.CurrentStockForOrder;

        }
        public void SetCurrentStockExternal(Stock stock) {
            //_codeBox.SetTextExternal(CodeDropDownDataProvider.DefaultFormat(stock.Profile));
            SetCurrentStock(stock);
        }

        private void SetCurrentStock(Stock stock) {
            
            IOrderItemFormatter formatter = BellagioRoot.OrderDataProvider.OrderItemFormatter;

            _volumeBox.SetTextByInt(stock==null? 0 : stock.VolumeUnit);
            _volumeBox.MaximumValue = 100000000;
            _volumeBox.ZeroFixedDigits = stock==null? 0 : GetZeroDigitsCountFromVolumeUnit(stock.VolumeUnit);
            if(_dealTypeGenbutsu.Visible) //ʂ܂Ăꍇ͕sv
                AdjustOrderType();

            if(stock!=null) {
                //_currentPriceButton.Enabled = true;
                _priceInfoTexts.priceRangeText = "";
                // Debug.WriteLine("GetStockSnapshot");
                BellagioRoot.OrderDataProvider.GetStockSnapshot(stock.Profile, new OrderDataProvider.StockSnapshotDelegate(ReceiveStockSnapshot)); //lXVɂ
                //AdjustPowerAmountInfo();
            }
            else {
                //_currentPriceButton.Enabled = false;
                _priceInfoTexts.priceRangeText = "";
            }
            AdjustTradeAmountLabel();
        }
        /*
        private RibbonMenuButton GetOrderTypeButton(OrderDealType deal, LongShort ls) {
            //Iv̂Ƃ͌EMp{^ŔE
            switch(deal) {
                case OrderDealType.Genbutsu:
                    return _newOrderGenbutsu;
                case OrderDealType.CreditSeido:
                case OrderDealType.CreditIppan:
                    return ls==LongShort.Long? _newOrderCreBuy : _newOrderCreSell;
                case OrderDealType.Derivatives:
                    return ls==LongShort.Long? _newOrderGenbutsu : _newOrderCreSell; ;
            }
            Debug.Assert(false);
            return null;
        }
        */
        private int GetSikkoBoxSelectedIndexFromOrderCondition(OrderCondition cond) {
            if(cond==OrderCondition.Sashine || cond==OrderCondition.Nariyuki)
                return 0; //Ȃ
            else if(cond==OrderCondition.Sashinari)
                return 3; //w
            else if(cond==OrderCondition.Hikenari || cond==OrderCondition.Hikesashi)
                return 2; //Q
            else //if(cond==OrderCondition.Yorinari || cond==OrderCondition.Yorisashi)
                return 1; //t
        }
        private OrderCondition SikkoBoxIndexToOrderCondition(int index, bool nariyuki) {
            if(index==0)
                return nariyuki? OrderCondition.Nariyuki : OrderCondition.Sashine;
            else if(index==1)
                return nariyuki? OrderCondition.Yorinari : OrderCondition.Yorisashi;
            else if(index==2)
                return nariyuki? OrderCondition.Hikenari : OrderCondition.Hikesashi;
            else
                return OrderCondition.Sashinari;
        }
        private void OnBuyOrSellButtonClick(object sender, MouseEventArgs args) {
            RibbonMenuButton b = (RibbonMenuButton)sender;
            //͕KvȂƂ̂ݎs
            if(b.Checked) return;
            _buyButton.Checked = b==_buyButton;
            _sellButton.Checked = b==_sellButton;
            //AdjustPowerAmountInfo();
            this.OrderContentChanged();
        }
        private void OnDealTypeCheckedChanged(object sender, MouseEventArgs args) {
            _dealTypeGenbutsu.Checked = sender==_dealTypeGenbutsu;
            _dealTypeSeido.Checked = sender==_dealTypeSeido;
            _dealTypeIppan.Checked = sender==_dealTypeIppan;
            Stock stock = GetCurrentStock();
            if((stock==null || !stock.Profile.IsDerivative) && _dealTypeGenbutsu.Checked) {
                _newPositionButton.Enabled = false;
                _closePositionButton.Enabled = false;
                _newPositionButton.Checked = false;
                _closePositionButton.Checked = false;
            }
            else { //Mp
                _newPositionButton.Enabled = true;
                _closePositionButton.Enabled = true;
                if(!_newPositionButton.Checked && !_closePositionButton.Checked)
                    _newPositionButton.Checked = true; //MpɕςƂ͐VKftHg
            }
            AdjustBuySellButtonText();
            //AdjustPowerAmountInfo();
            this.OrderContentChanged();
        }
        private void OnNewOrCloseCheckedChanged(object sender, MouseEventArgs args) {
            _newPositionButton.Checked = sender==_newPositionButton;
            _closePositionButton.Checked = sender==_closePositionButton;
            AdjustBuySellButtonText();
            //AdjustPowerAmountInfo();
            this.OrderContentChanged();
        }

        private void AdjustOrderType() {
            bool credit_account = BellagioRoot.OrderDataProvider.AccountInfo.CreditAccountEnabled;
            AbstractStockProfile prof = _host.CurrentStockProfile;
            Stock stock = _host.CurrentStockForOrder;

            if(prof!=null && OrderingUtil.IsFutureOrOption(prof.Flags)) {
                _orderTypeLabel.Text = "^Cv";
                _dealTypeGenbutsu.Text = "ʏ";
                _dealTypeSeido.Visible = _dealTypeIppan.Visible = false;
                _dealTypeGenbutsu.Checked = true;
                _dealTypeSeido.Checked = _dealTypeIppan.Checked = false;
                _newPositionButton.Enabled = _closePositionButton.Enabled = true;
            }
            else {
                _orderTypeLabel.Text = "";
                _dealTypeGenbutsu.Text = "";
                _dealTypeSeido.Visible = _dealTypeIppan.Visible = true;
                _dealTypeSeido.Enabled = credit_account && (stock==null || (stock.StockFlags & (StockFlags.Seido|StockFlags.Taisyaku))!=StockFlags.None);
                _dealTypeIppan.Enabled = credit_account && (stock==null || (stock.StockFlags & StockFlags.Ippan)!=StockFlags.None);
                //Mp`FbNO
                if(!_dealTypeSeido.Enabled && _dealTypeSeido.Checked) { _dealTypeSeido.Checked = false; _dealTypeGenbutsu.Checked = true; }
                if(!_dealTypeIppan.Enabled && _dealTypeIppan.Checked) { _dealTypeIppan.Checked = false; _dealTypeGenbutsu.Checked = true; }
                _newPositionButton.Enabled = _closePositionButton.Enabled = !_dealTypeGenbutsu.Checked;
                if(!_newPositionButton.Enabled && _newPositionButton.Checked) _newPositionButton.Checked = false;
                if(!_closePositionButton.Enabled && _closePositionButton.Checked) _closePositionButton.Checked = false;
            }

            AdjustBuySellButtonText();
            AdjustKouzaBox(false);
        }
        /*
        private void AdjustCreditLabel() {
            Stock st = GetCurrentStock();
            if(st!=null && !OrderingUtil.IsFutureOrOption(st.Profile.Flags) && !_newOrderGenbutsu.Checked) {
                StockFlags f = st.StockFlags & (StockFlags.Seido | StockFlags.Ippan);
                if(f!=StockFlags.None) { //炩̗LȐMp}XN
                    _creditTypeBox.Items.Clear();
                    _creditTypeBox.Items.Add("x");
                    _creditTypeBox.Items.Add("");
                    if(_newOrderCreSell.Checked || f==StockFlags.Seido) { //Mp݂Ƃ͎Iɐx
                        _creditTypeBox.SelectedIndex = 0;
                        _creditTypeBox.Enabled = false;
                    }
                    else if(f==StockFlags.Ippan) {
                        _creditTypeBox.SelectedIndex = 1;
                        _creditTypeBox.Enabled = false;
                    }
                    else { //w\
                        _creditTypeBox.Enabled = true;
                        TradeOrderItem item = _parameter.CurrentOrder;
                        _creditTypeBox.SelectedIndex = item!=null && item.DealType==OrderDealType.CreditIppan? 1 : 0;
                    }
                    return;
                }
            }

            //ȏꍇ
            _creditTypeBox.Items.Clear();
            _creditTypeBox.Items.Add("--");
            _creditTypeBox.Enabled = false;
            _creditTypeBox.SelectedIndex = 0;
        }
        */
        private void AdjustKouzaBox(bool for_init_content) {
            Stock st = GetCurrentStock();
            if(st==null || OrderingUtil.IsFutureOrOption(st.Profile.Flags)) {
                _kouzaBox.Items.Clear();
                _kouzaBox.Items.Add("--");
                _kouzaBox.Enabled = false;
                _kouzaBox.SelectedIndex = 0;
            }
            else {
                int old_index = _kouzaBox.SelectedIndex;
                _kouzaBox.Items.Clear();
                _kouzaBox.Items.Add("");
                _kouzaBox.Items.Add("");
                if(_parameter.OrderCategory==OrderFormParameter.Category.NewPosition) {
                    if(BellagioRoot.DataSourceHost.ExternalEnvironment.AccountInfo.TokuteiKouzaAvailable) {
                        _kouzaBox.Enabled = true;
                        TradeOrderItem item = _parameter.CurrentOrder;
                        if(for_init_content) //ŏ̏
                            _kouzaBox.SelectedIndex = item!=null && item.Kouza==OrderKouza.Ippan? 1 : 0;
                        else
                            _kouzaBox.SelectedIndex = old_index==1? 1 : 0; //old_index==-1肤
                    }
                    else {
                        _kouzaBox.Enabled = false;
                        _kouzaBox.SelectedIndex = 1;
                    }
                }
                else {
                    _kouzaBox.Enabled = false;
                    _kouzaBox.SelectedIndex = (_parameter.OrderCategory==OrderFormParameter.Category.ClosePosition? _parameter.CurrentPosition.OrderKouza : _parameter.CurrentOrder.Kouza)==OrderKouza.Tokutei? 0 : 1;
                }
            }
        }
        private void AdjustBuySellButtonText() {
            //敨orMp
            AbstractStockProfile prof = _host.CurrentStockProfile;
            if((prof!=null && prof.IsDerivative) || _dealTypeSeido.Checked || _dealTypeIppan.Checked) {
                if(_newPositionButton.Checked) {
                    _buyButton.Text = "VK";
                    _sellButton.Text = "VK";
                }
                else if(_closePositionButton.Checked) {
                    _buyButton.Text = "ԍϔ";
                    _sellButton.Text = "ԍϔ";
                }
                else {
                    _buyButton.Text = "";
                    _sellButton.Text = "";
                }
            }
            else if(_dealTypeGenbutsu.Checked) {
                _buyButton.Text = "";
                _sellButton.Text = "";
            }
            else {
                _buyButton.Text = "";
                _sellButton.Text = "";
            }
    
        }
        /*
        private void OnMaxVolumeButtonClick(object sender, EventArgs args) {
            if(_stockProfile==null) return;

            //S̓{^@̂Ƃ̒ԂɉĒ\ő吔ʂZbg
            //case1 敨
            if(_stockProfile.IsDerivative) {
                DerivativeBuyingPowerInfo info = BellagioRoot.OrderDataProvider.DerivativeBuyingPowerInfo.Value;
                if(info==null) return;
                //͊ȒPB]͏ɔ\Ă
                _volumeBox.SetTextByInt(info.GetMaxVolumeFor((DerivativeStockProfile)_stockProfile, _otCreSell.Checked? LongShort.Short : LongShort.Long));
            }
            else  { //case2 Mp
                StockBuyingPowerInfo info = BellagioRoot.OrderDataProvider.StockBuyingPowerInfo.Value;
                if(info==null) return;

                //TODO l悤ɂȂAsŵƂ͎wl̒lłȂlŌvZ
                int vol = (int)(((_otCreBuy.Checked || _otCreSell.Checked)? info.Credit : info.Genbutsu) / (_sashineBox.GetTextAsInt()));
                int unit = _stockProfile==null? 1000 : _stockProfile.VolumeUnit;
                vol -= vol % unit; //܂؂̂

                _volumeBox.SetTextByInt(vol);
            }

        }
        */

        //wlύX
        private void OnSashineChangeButtonClick(object sender, MouseEventArgs args) {
            if(args.Button!=MouseButtons.Left) return;

            if(sender==_sashineDec10) ChangeSashine(false, true);
            else if(sender==_sashineDec) ChangeSashine(false, false);
            else if(sender==_sashineInc) ChangeSashine(true, false);
            else if(sender==_sashineInc10) ChangeSashine(true, true);

            this.OrderContentChanged();

        }
        private void OnMouseWheelSashine(object sender, MouseEventArgs args) {
            ChangeSashine(args.Delta>0, false);
            this.OrderContentChanged();
        }
        public void SetSashineExternal(int price) {
            _nariyukiButton.Checked = false;
            SetSashineBoxEnabled(true);
            _sashineBox.SetTextByInt(price);
            AdjustTradeAmountLabel();
        }
        private void ChangeSashine(bool increment, bool ten_times) {
            if(!_sashineBox.Enabled) return;
            int price = _sashineBox.GetTextAsInt();
            AbstractStockProfile prof = _host.CurrentStockProfile;
            if(ten_times) {
                int y = MarketUtil.YobineIncrement(prof.Primary, price)-price;
                price = MarketUtil.AdjustNearestYobine(prof.Primary, price + y * (increment? 10 : -10));
            }
            else
                price = increment? YobineIncrement(prof, price) : YobineDecrement(prof, price);

            if(price < 1) price = 1;
            if(price > _sashineBox.MaximumValue) price = _sashineBox.MaximumValue;
            _sashineBox.SetTextByInt(price);

            AdjustTradeAmountLabel();
        }

        //̌Ăђl܂ő/B敨E~ĵƂ͒ʏƈႤ̂ŕʈ
        private static int YobineIncrement(AbstractStockProfile s, int p) {
            DerivativeStockProfile d = s as DerivativeStockProfile;
            if(d!=null) {
                int step = MarketUtil.GetDerivativeYobine(d);
                return p - (p % step) + step; //[͐؂̂
            }
            else
                return MarketUtil.YobineIncrement(p);
        }
        private static int YobineDecrement(AbstractStockProfile s, int p) {
            DerivativeStockProfile d = s as DerivativeStockProfile;
            if(d!=null) {
                int step = MarketUtil.GetDerivativeYobine(d);
                return p - (p % step) - step; //[͐؂̂
            }
            else
                return MarketUtil.YobineDecrement(p);
        }

        private void OnNariyukiButtonClick(object sender, EventArgs args) {
            bool c = _nariyukiButton.Checked; //̓{ǂŕω
            _nariyukiButton.Checked = c;
            SetSashineBoxEnabled(!c);
            AdjustTradeAmountLabel();
            this.OrderContentChanged();
        }

        //_priceInfoIconMouseEnter/Leaveɂ̃nhڑƁAWinXPŖpMouseLeaveĖʓ|ȂƂɂȂ

        private ToolTip _priceInfoToolTip;
        private void OnPriceInfoMouseEnter(object sender, EventArgs args) {
            if(_priceInfoToolTip==null) _priceInfoToolTip = new ToolTip();
            string text = FormatPriceInfoText();
            _priceInfoToolTip.Hide(this); //Active -> Show̏łȂƕ\ȂAHideĂ΂ȂƑǑĂяoŃZbgeLXgc
            _priceInfoToolTip.Active = true;
            _priceInfoToolTip.Show(text, this, this.PointToClient(Control.MousePosition), 3600000);
        }
        private void OnPriceInfoMouseLeave(object sender, EventArgs args) {
            _priceInfoToolTip.Active = false;
        }

        //đֈ
        private bool _onEnteringMouseMove;
        private void OnMouseMoveForPriceInfoIcon(object sender, MouseEventArgs args) {
            bool enter = _priceInfoIcon.Bounds.Contains(this.PointToClient(Control.MousePosition));
            if(_onEnteringMouseMove != enter) {
                if(enter)
                    OnPriceInfoMouseEnter(_priceInfoIcon, null);
                else
                    OnPriceInfoMouseLeave(_priceInfoIcon,null);
                _onEnteringMouseMove = enter;
            }
        }

        private void AdjustTradeAmountLabel() {
            Stock stock = GetCurrentStock();
            if(!_nariyukiButton.Checked && stock!=null) {
                int sashine = _sashineBox.GetTextAsInt();
                int volume = _volumeBox.GetTextAsInt();
                if(sashine!=0 && volume!=0) {
                    long p = volume;
                    p = p * sashine * stock.Profile.ImplicitPriceFactor;
                    _priceInfoTexts.tradeAmountText = String.Format("{0:N0}~", p);
                    return;
                }
            }

            _priceInfoTexts.tradeAmountText = "";
        }

        private string FormatPriceInfoText() {
            StringBuilder bld = new StringBuilder();
            if(!String.IsNullOrEmpty(_priceInfoTexts.priceRangeText))
                bld.Append("\l@@ ").Append(_priceInfoTexts.priceRangeText).Append("\n");
            string powerLabel, powerText;
            if(GetPowerAmountText(out powerLabel, out powerText))
                bld.Append(powerLabel).Append(" ").Append(powerText).Append("\n");
            if(!String.IsNullOrEmpty(_priceInfoTexts.tradeAmountText))
                bld.Append("TZ ").Append(_priceInfoTexts.tradeAmountText).Append("\n");

            //Xg̉s
            if(bld.Length>0) bld.Remove(bld.Length-1, 1);

            return bld.ToString();

        }

        //lEXV
        private void ReceiveStockSnapshot(AsyncOpResult result, OrderDataStockSnapshot snapshot) {
            try {
                _priceInfoTexts.priceRangeText = ""; //܂Zbg

                if(result==AsyncOpResult.Succeeded) {
                    if(snapshot.UpperLimitPrice!=OrderDataStockSnapshot.EMPTY_VALUE && snapshot.LowerLimitPrice!=OrderDataStockSnapshot.EMPTY_VALUE) {
                        _priceInfoTexts.priceRangeText = String.Format("{0:N0} - {1:N0}~", snapshot.LowerLimitPrice, snapshot.UpperLimitPrice);
                    }
                    //̌lŁAƂ(Aۗ̕)͎wl}͂Ȃ
                    if(snapshot.CurrentPrice!=OrderDataStockSnapshot.EMPTY_VALUE &&
                        _parameter.CurrentOrder==null) {
                        _sashineBox.SetTextByInt(snapshot.CurrentPrice);
                        _sashineBox.Focus();
                        _nariyukiButton.Checked = false;
                        SetSashineBoxEnabled(true);
                        this.OrderContentChanged();
                    }

                }

                _stockSnapshot = snapshot;
                AdjustTradeAmountLabel();
            }
            catch(Exception ex) {
                Debug.WriteLine(ex.Message);
                Debug.WriteLine(ex.StackTrace);
            }
        }

        //ʕύX
        private void OnVolumeChangeButtonClick(object sender, MouseEventArgs args) {
            if(args.Button!=MouseButtons.Left) return;

            if(sender==_volumeDec10) ChangeVolume(false, true);
            else if(sender==_volumeDec) ChangeVolume(false, false);
            else if(sender==_volumeInc) ChangeVolume(true, false);
            else if(sender==_volumeInc10) ChangeVolume(true, true);

            this.OrderContentChanged();
        }
        private void OnMouseWheelVolume(object sender, MouseEventArgs args) {
            ChangeVolume(args.Delta>0, false);
            this.OrderContentChanged();
        }
        private void ChangeVolume(bool increment, bool ten_times) {
            if(!_volumeBox.Enabled) return;

            int volume = _volumeBox.GetTextAsInt();
            int u = _host.CurrentStockForOrder==null? 1 :  _host.CurrentStockForOrder.VolumeUnit;
            if(ten_times) {
                if(increment) {
                    volume -= volume % (u*10);
                    volume += u * 10;
                }
                else {
                    int m = volume % (u*10);
                    if(m > 0) volume += (u*10) - m;
                    volume -= u * 10;
                }
            }
            else {
                volume += increment? u : -u;
            }


            if(volume < u) volume = u;
            if(volume > _volumeBox.MaximumValue) volume = _volumeBox.MaximumValue;

            _volumeBox.SetTextByInt(volume);
            AdjustVolumeInGrid(volume);

            AdjustTradeAmountLabel();
        }
        private void OnPaintCurrentPositionOrOrder(object sender, PaintEventArgs args) {
            try {
                if(_parameter==null) return;

                IOrderItemFormatter fmt = BellagioRoot.OrderDataProvider.OrderItemFormatter;
                Font f = _currentPositionOrOrder.Font; //ftHgtHg, uV
                Brush b = SystemBrushes.WindowText;
                Graphics g = args.Graphics;
                //PsڂɎʁAQsڂɐʁARsڂɒP{\

                if(_parameter.OrderCategory==OrderFormParameter.Category.ClosePosition) {
                    TradePositionItem pos = _parameter.CurrentPosition;
                    int volume = _parameter.CloseType==OrderFormParameter.ClosePositionType.MultiplePosition? pos.TotalVolume : _parameter.PositionElement.Volume;
                    bool multiple = pos.DealType!=OrderDealType.Genbutsu && _parameter.CloseType==OrderFormParameter.ClosePositionType.MultiplePosition;

                    int x = 0;
                    int y = 0;
                    DrawStringUtil.ToRight(g, FormatCurrentPosition(fmt, pos), f, OrderingUtil.IsLong(pos.LongShort)? _buyMarkBrush : _sellMarkBrush, ref x, y);
                    if(pos.DealType!=OrderDealType.Genbutsu && !multiple) {
                        DrawStringUtil.ToRight(g, "     ", f, b, ref x, y);
                        DrawStringUtil.ToRight(g, BDate.FormatYYMMDD(_parameter.PositionElement.Date), f, b, ref x, y);
                    }

                    x = 0;
                    y = DrawStringUtil.GetFontHeightAsInt(f, g);
                    DrawStringUtil.ToRight(g, pos.DealType==OrderDealType.Genbutsu? "ۗL " : "ʐ ", f, b, ref x, y);
                    DrawStringUtil.ToRight(g, volume.ToString("N0"), _figureFont, _figureBrush, ref x, y + _figureFontYOffset);
                    DrawStringUtil.ToRight(g, pos.Stock.Profile.VolumeUnitString, f, b, ref x, y);
                    if(pos.TotalOrderingVolume!=0) {
                        DrawStringUtil.ToRight(g, "( ", f, b, ref x, y);
                        DrawStringUtil.ToRight(g, pos.TotalOrderingVolume.ToString(), _figureFont, _figureBrush, ref x, y + _figureFontYOffset);
                        DrawStringUtil.ToRight(g, pos.Stock.Profile.VolumeUnitString, f, b, ref x, y);
                        DrawStringUtil.ToRight(g, ")", f, b, ref x, y);
                    }

                    if(_parameter.CloseType==OrderFormParameter.ClosePositionType.SpecifiedElement) {
                        x = 0;
                        y += DrawStringUtil.GetFontHeightAsInt(f, g);
                        DrawStringUtil.ToRight(g, pos.DealType==OrderDealType.Genbutsu? "擾P " : "P@ ", f, b, ref x, y);
                        string price = (_parameter.PositionElement.Price100/100).ToString("N0");
                        DrawStringUtil.ToRight(g, price, _figureFont, _figureBrush, ref x, y + _figureFontYOffset);
                        DrawStringUtil.ToRight(g, "~", f, b, ref x, y);
                    }
                }
                else if(_parameter.OrderCategory==OrderFormParameter.Category.Change) {
                    TradeOrderItem order = _parameter.CurrentOrder;
                    int x = 0;
                    int y = 0;
                    Brush br = order.IsBuying? _buyMarkBrush : _sellMarkBrush;
                    DrawStringUtil.ToRight(g, order.DealType==OrderDealType.Genbutsu? "" : OrderingUtil.IsShinnyo(order.DealType)? "Mp" : "", f, br, ref x, y);
                    DrawStringUtil.ToRight(g, fmt.FormatTradeDescription(order.DealType, order.LongShort, order.NewOrClose), f, br, ref x, y);
                    if(OrderingUtil.IsShinnyo(order.DealType)) {
                        DrawStringUtil.ToRight(g, "(", f, br, ref x, y);
                        DrawStringUtil.ToRight(g, fmt.FormatShinnyoKubun(order.DealType), f, br, ref x, y);
                        DrawStringUtil.ToRight(g, ")", f, br, ref x, y);
                    }

                    x = 0;
                    y += DrawStringUtil.GetFontHeightAsInt(f, g);
                    DrawStringUtil.ToRight(g, " ", f, b, ref x, y);
                    DrawStringUtil.ToRight(g, order.Volume.ToString("N0"), _figureFont, _figureBrush, ref x, y + _figureFontYOffset);
                    DrawStringUtil.ToRight(g, order.Stock.Profile.VolumeUnitString, f, b, ref x, y);
                    if(order.TradedVolume!=0) {
                        PartialTradeDisplay pd = BellagioRoot.FixedPreferences.Ordering.PartialTradeDisplay;
                        int partial_vol = pd==PartialTradeDisplay.Traded? order.TradedVolume : order.Volume - order.TradedVolume;
                        DrawStringUtil.ToRight(g, pd==PartialTradeDisplay.Traded? "( " : "( ", f, b, ref x, y);
                        DrawStringUtil.ToRight(g, partial_vol.ToString("N0"), _figureFont, _figureBrush, ref x, y + _figureFontYOffset);
                        DrawStringUtil.ToRight(g, order.Stock.Profile.VolumeUnitString, f, b, ref x, y);
                        DrawStringUtil.ToRight(g, ")", f, b, ref x, y);
                    }

                    x = 0;
                    y += DrawStringUtil.GetFontHeightAsInt(f, g);
                    DrawStringUtil.ToRight(g, fmt.FormatOrderCondition(order.Condition), f, b, ref x, y);
                    if(OrderingUtil.IsSashineRequired(order.Condition)) {
                        x += 5;
                        DrawStringUtil.ToRight(g, order.AdjustPriceI(order.Sashine).ToString("N0"), _figureFont, _figureBrush, ref x, y + _figureFontYOffset);
                        DrawStringUtil.ToRight(g, "~", f, b, ref x, y);
                    }
                    if(OrderingUtil.IsTriggerAvailable(order.TriggerType)) {
                        DrawStringUtil.ToRight(g, "  (twl ", f, b, ref x, y);
                        DrawStringUtil.ToRight(g, order.AdjustPriceI(order.TriggerPrice).ToString("N0"), _figureFont, _figureBrush, ref x, y + _figureFontYOffset);
                        DrawStringUtil.ToRight(g, "~", f, b, ref x, y);
                        DrawStringUtil.ToRight(g, order.TriggerType==OrderTriggerType.UpperBreak? "ȏ)" : "ȉ)", f, b, ref x, y);
                    }
                }
            }
            catch(Exception ex) {
                RuntimeUtil.ReportException(ex);
            }
        }
        private string FormatCurrentPosition(IOrderItemFormatter fmt, TradePositionItem pos) {
            StringBuilder bld = new StringBuilder();
            bld.Append(fmt.FormatPosition(pos.DealType, pos.LongShort));
            if(OrderingUtil.IsShinnyo(pos.DealType)) {
                bool change = _parameter.OrderCategory==OrderFormParameter.Category.Change;
                //ύXƕԍςŐMp̕قȂ
                bld.Append(" (").Append(change? fmt.FormatShinnyoKubun(pos.DealType) : fmt.FormatShinnyoKigen(pos.DealType)).Append(")");
            }
            return bld.ToString();
        }


        //ԍς̌ʏڍ׊֌WUI
        private const int VOLUME_COLUMN = 3;
        private DataGridView CreatePositionDetailListView() {
            BellagioDataGrid g = new BellagioDataGrid();
            g.ColumnCount = 4;
            g.Font = new Font(FontFamily.GenericSerif, 8);
            g.ColumnHeadersDefaultCellStyle.Font = new Font(FontFamily.GenericSerif, 8.0F);
            g.EditMode = DataGridViewEditMode.EditOnEnter|DataGridViewEditMode.EditOnF2;
            g.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.DisableResizing;
            g.AllowUserToAddRows = false;
            g.AllowUserToDeleteRows = false;
            g.RowHeadersVisible = false;
            g.ColumnHeadersBorderStyle = DataGridViewHeaderBorderStyle.Raised;
            g.CellBeginEdit += new DataGridViewCellCancelEventHandler(OnBeforePositionDetailEdit);
            g.CellValidated += new DataGridViewCellEventHandler(OnAfterPositionDetailEdit);
            g.CellValidating += new DataGridViewCellValidatingEventHandler(OnValidatingPositionDetailEdit);
            g.PrivateMouseWheel = new BellagioDataGrid.MouseWheelDelegate(OnDataGridMouseWheel);
            g.ScrollBars = ScrollBars.Vertical;
            SetDataGridColumn(g, 0, "", 60, false);
            SetDataGridColumn(g, 1, "P", 48, false);
            SetDataGridColumn(g, 2, "", 48, false);
            SetDataGridColumn(g, 3, "", 48, true);

            return g;
        }
        private void SetDataGridColumn(DataGridView g, int index, string text, int width, bool editable) {
            DataGridViewColumn c = g.Columns[index];
            c.HeaderText = text;
            c.Width = width;
            c.ValueType = typeof(string);
            if(!editable)
                c.DefaultCellStyle.BackColor = Color.LightGray;
        }
        //ۗ玝Ăꍇ̂current_order
        private void InitPositionDetailListContent(TradeOrderItem current_order) {
            PositionAndVolumeList ordering_positions = current_order==null? null : current_order.ClosePositionDetail;
            _positionDetailList.CancelEdit();
            _positionDetailList.Rows.Clear();
            _positionDetailList.BringToFront();
            object x = null;
            bool buying = _parameter.CurrentPosition.LongShort==LongShort.Long; //̓|WVOǂ
            List<TradePositionItem.Element> elements = _parameter.CurrentPosition.ElementCollectionCopy();
            elements.Sort(delegate(TradePositionItem.Element e1, TradePositionItem.Element e2) {
                if(e1.DateAsInt!=e2.DateAsInt)
                    return e1.DateAsInt - e2.DateAsInt; //܂tD
                else if(buying)
                    return e2.Price100 - e1.Price100; //tȂP
                else
                    return e1.Price100 - e2.Price100;
            });
            for(int i=0; i<elements.Count; i++) {
                TradePositionItem.Element e = elements[i];
                int left_vol = e.Volume-e.OrderingVolume;
                int initial_vol = ordering_positions==null? left_vol : Math.Min(left_vol, ordering_positions.Find(e.UniqueID));
                _positionDetailList.Rows.Add(BDate.FormatYYMMDD(e.Date), (e.Price100/100).ToString(), left_vol.ToString(), initial_vol.ToString());
                DataGridViewRow r = _positionDetailList.Rows[_positionDetailList.Rows.Count-1];
                r.Resizable = DataGridViewTriState.False;
                r.Tag = e;
                x = r.Cells[3].Value;
            }
        }
        private void OnResizeCurrentPositionOrOrder(object sender, EventArgs args) {
            _positionDetailList.Location = new Point(_currentPositionOrOrder.Left, _currentPositionOrOrder.Top + 32);
            _positionDetailList.Size = new Size(_currentPositionOrOrder.Width-4, _currentPositionOrOrder.Height - 32);
        }
        private void ResizeOrderPanel(bool detail_grid_visible) {
            if(detail_grid_visible) //_positionDetailList.Visible ́AFormĂȂƏɔ\
                _gridMainRectOp.Rect(this.ClientRectangle);
            else
                _regularMainRectOp.Rect(this.ClientRectangle);
            //Debug.WriteLine(String.Format("ROP grid={0} pos_dt={1} price={2}", detail_grid_visible, _positionOrDealTypeRect.Top, _priceAndVolumeRect.Top));
            //Ƃ͊evf
            //_codeBoxRectOp.Rect(_codeBoxRect.Value);
            _positionOrDealTypeRectOp.Rect(_positionOrDealTypeRect.Value);
            _priceAndVolumeRectOp.Rect(_priceAndVolumeRect.Value);
        }
        protected override void OnResize(EventArgs args) {
            base.OnResize(args);
            ResizeOrderPanel(_positionDetailListVisible);
        }

        private void OnBeforePositionDetailEdit(object sender, DataGridViewCellCancelEventArgs args) {
            if(args.ColumnIndex!=VOLUME_COLUMN) args.Cancel = true;
        }
        private void OnAfterPositionDetailEdit(object sender, DataGridViewCellEventArgs args) {
            if(args.ColumnIndex!=VOLUME_COLUMN) return;
            //g[^ʂA
            _volumeBox.SetTextByInt(GetTotalVolumeInGrid());
            this.OrderContentChanged();
        }
        private int GetTotalVolumeInGrid() {
            int vol = 0;
            for(int i=0; i<_positionDetailList.Rows.Count; i++) {
                DataGridViewCell cell = _positionDetailList.Rows[i].Cells[VOLUME_COLUMN];
                vol += Int32.Parse((string)cell.Value);
            }
            return vol;
        }
        private void OnValidatingPositionDetailEdit(object sender, DataGridViewCellValidatingEventArgs args) {
            if(args.ColumnIndex!=VOLUME_COLUMN || !_positionDetailList.Visible) return; //VKJȂƂȂǁAĂȂ̂ɃCxg邱Ƃ

            DataGridViewRow row = _positionDetailList.Rows[args.RowIndex];
            DataGridViewCell cell = row.Cells[args.ColumnIndex];
            row.ErrorText = "";

            int value;
            if(!Int32.TryParse((string)args.FormattedValue, out value)) {
                args.Cancel = true;
                BUtil.ShowWarningMessageBox("l͂Ă");
                return;
            }
            TradePositionItem.Element elem = row.Tag as TradePositionItem.Element;
            if(value < 0 || value > (elem.Volume-elem.OrderingVolume)) {
                args.Cancel = true;
                BUtil.ShowWarningMessageBox("LȐlł͂܂");
                return;
            }

            if(value % _host.CurrentStockProfile.VolumeUnit != 0) { //Pʊ̂܂
                args.Cancel = true;
                BUtil.ShowWarningMessageBox("Pʊ̔{͂Ă");
                return;
            }
        }
        //}EXzC[ł̐ʕύX݂
        private bool OnDataGridMouseWheel(int delta) {
            if(_positionDetailList.EditingControl!=null) return false;

            DataGridViewSelectedCellCollection c = _positionDetailList.SelectedCells;
            if(c.Count!=1) return false;
            DataGridViewCell cell = c[0];
            if(cell.ColumnIndex!=VOLUME_COLUMN) return false;

            TradePositionItem.Element elem = cell.OwningRow.Tag as TradePositionItem.Element;
            int vol = Int32.Parse((string)cell.Value);
            int unit = _host.CurrentStockProfile.VolumeUnit;
            vol = delta>0? vol + unit : vol - unit;
            if(vol < 0) vol = 0;
            else if(vol > (elem.Volume-elem.OrderingVolume)) vol = (elem.Volume-elem.OrderingVolume);

            cell.Value = vol.ToString();
            //ŜA
            _volumeBox.SetTextByInt(GetTotalVolumeInGrid());
            this.OrderContentChanged();
            AdjustTradeAmountLabel();
            return true;
        }

        private void AdjustVolumeInGrid(int newvalue) {
            if(_parameter.OrderCategory!=OrderFormParameter.Category.ClosePosition || _parameter.CloseType!=OrderFormParameter.ClosePositionType.MultiplePosition) return;
            Debug.Assert(_positionDetailList.Visible);

            int left = newvalue - GetTotalVolumeInGrid();
            if(left==0) return;

            //̗񂩂ύX
            for(int i=_positionDetailList.Rows.Count-1; i>=0; i--) {
                DataGridViewRow r = _positionDetailList.Rows[i];
                DataGridViewCell cell = r.Cells[VOLUME_COLUMN];
                int vol = Int32.Parse((string)cell.Value);
                if(left > 0) { //ʑ
                    int add = Math.Min(left, ((TradePositionItem.Element)r.Tag).Volume - vol);
                    cell.Value = (vol + add).ToString();
                    left -= add;
                }
                else if(left < 0) { //ʌ
                    int sub = Math.Min(-left, vol);
                    cell.Value = (vol - sub).ToString();
                    left += sub;
                }
                if(left==0) break;
            }

        }
        private PositionAndVolumeList CreatePositionAndVolumeList() {
            PositionAndVolumeList l = new PositionAndVolumeList();
            //Debug.Assert(_positionDetailList.Visible);
            for(int i=0; i<_positionDetailList.Rows.Count; i++) {
                DataGridViewRow row = _positionDetailList.Rows[i];
                DataGridViewCell cell = row.Cells[VOLUME_COLUMN];
                int vol = Int32.Parse((string)cell.Value);
                if(vol!=0) l.Add(((TradePositionItem.Element)row.Tag).UniqueID, vol);
            }
            return l;
        }

        private void SetSashineBoxEnabled(bool value) {
            _nariyukiButton.Checked = !value;
            _nariyukiButton.Image = BellagioRoot.CommonIcons.SmallCommandButtons.GetBitmap(_nariyukiButton.Checked? 5 : 6);
            _sashineBox.Enabled = value;
            _sashineBox.BackColor = value? _backColor : Color.FromArgb(64, 64, 64);
            _sashineBox.ForeColor = value? _foreColor : Color.Black;
        }
        private void ReceiveStockBuyingPowerInfo() {
            if(this.IsDisposed || !this.Visible) return;

            if(BellagioRoot.OrderDataProvider.StockBuyingPowerInfo.Value!=null) {
                _stockPowerInfo = BellagioRoot.OrderDataProvider.StockBuyingPowerInfo.Value.Clone();
                BellagioRoot.OrderDataProvider.DerivativeBuyingPowerInfo.Refresh();
            }
        }
        private void ReceiveDerivativeBuyingPowerInfo() {
            if(this.IsDisposed || !this.Visible) return;
            if(BellagioRoot.OrderDataProvider.DerivativeBuyingPowerInfo.Value!=null) {
                _derivativePowerInfo = BellagioRoot.OrderDataProvider.DerivativeBuyingPowerInfo.Value.Clone();
            }
        }
        //ReLXgj[
        /*
        private void OnContextMenu(object sender, MouseEventArgs e) {
            base.OnMouseUp(e);
            if(e.Button==MouseButtons.Right ) {
                if(!_codeBox.EnabledEx) return;

                ContextMenuStrip cm = new ContextMenuStrip();
                IPoderosaMenuGroup[] menus = new IPoderosaMenuGroup[] {
                    new Bellagio.Chart.ChartMenuGroups.FutureMenuGroup(new SetStockCommand((OrderForm)this.ParentForm), false) };
                Poderosa.Forms.PublicMenuUtil.BuildContextMenu(cm, menus, null);

                try {
                    cm.Show((Control)sender, e.Location);
                }
                catch(Exception ex) {
                    RuntimeUtil.ReportException(ex);
                }

            }
        }
        */
        /*
        private class SetStockCommand : PoderosaCommandImpl {
            private OrderForm _form;
            public SetStockCommand(OrderForm f) {
                _form = f;
            }
            public override CommandResult InternalExecute(ICommandTarget target, params IAdaptable[] args) {
                AbstractStockProfile prof = (AbstractStockProfile)args[0].GetAdapter(typeof(AbstractStockProfile));
                _form.SetCurrentStockExternal(prof);
                return CommandResult.Succeeded;
            }
        }
        */

        //xݒ
        private bool GetPowerAmountText(out string label, out string text) {
            label = "";
            text = "";
            try {
                AbstractStockProfile prof = _host.CurrentStockProfile;
                if(prof!=null && prof.IsDerivative) {
                    if(_derivativePowerInfo!=null) {
                        if(_derivativePowerInfo.MarginDeficiency > 0) {
                            label = "؋sz";
                            text = String.Format("{0:N0}~", _derivativePowerInfo.MarginDeficiency);
                        }
                        else {
                            bool mini = prof!=null && prof.IsDerivative && ((DerivativeStockProfile)prof).Brand==DerivativeStockProfile.BrandT.NikkeiFutureMini;
                            label = "/\";
                            text = String.Format("{0:N0}/{1:N0}", mini? _derivativePowerInfo.maxVolumeMiniLong : _derivativePowerInfo.maxVolumeLargeLong, mini? _derivativePowerInfo.maxVolumeMiniShort : _derivativePowerInfo.maxVolumeLargeShort, mini? "(mini)" : "");
                        }
                        return true;
                    }
                }
                else { //_stockProfilenull̂Ƃ͌/Mp
                    if(_stockPowerInfo!=null) {
                        bool credit = (_dealTypeSeido.Checked || _dealTypeIppan.Checked);

                        if(credit) {
                            label = "Mp]";
                            text  = String.Format("{0:N0}~", _stockPowerInfo.Credit);
                        }
                        else {
                            label = "t]";
                            text  = String.Format("{0:N0}~", _stockPowerInfo.Genbutsu);
                        }
                        return true;
                    }
                }
                return false;
            }
            catch(Exception ex) {
                RuntimeUtil.ReportException(ex);
                return false;
            }
        }

        //TradeOrderItem̍쐬Bݒ肪܂΃bZ[W{bNXonullԂ
        public TradeOrderItem CreateTradeOrderItemUI() {
            return CreateTradeOrderItem(true);
        }
        //TradeOrderItem̍쐬BsڂĂł邾̃vpeB𖄂߂ĕԂ
        public TradeOrderItem CreateTradeOrderItemSilent() {
            return CreateTradeOrderItem(false);
        }

        //TradeOrderItem̍쐬Bݒ肪܂΃bZ[W{bNXonullԂ
        private TradeOrderItem CreateTradeOrderItem(bool show_messagebox) {
            Stock stock = GetCurrentStock();
            if(show_messagebox) {
                if(stock==null) {
                    CreateTradeOrderItemUIFail("͂Ă܂");
                    return null;
                }
                /*
                if(_codeBox.EnabledEx && stock.Profile.Code != _codeBox.GetCodeText()) { //r[ɃR[h͂ȂĂ狑
                    CreateTradeOrderItemUIFail("͂܂");
                    return null;
                }
                */
                if(_volumeBox.GetTextAsInt()==0) {
                    CreateTradeOrderItemUIFail("ʂ͂Ă܂");
                    return null;
                }
                if(!_nariyukiButton.Checked) {
                    int sashine = _sashineBox.GetTextAsInt();
                    if(sashine<=0) {
                        CreateTradeOrderItemUIFail("LȎwl͂Ă܂");
                        return null;
                    }
                }
            }

            TradeOrderItem item;
            IOrderItemFormatter formatter = BellagioRoot.OrderDataProvider.OrderItemFormatter;

            //stocknull
            if(_parameter.OrderCategory==OrderFormParameter.Category.NewPosition) {
                item = new TradeOrderItem(stock);
                item.OrderStatus = OrderStatus.Ordered;
                item.MarketAsText = stock==null? null : new string[] { formatter.FormatStockExchange(stock.Market) };
                if(!_buyButton.Checked && !_sellButton.Checked) {
                    if(show_messagebox) CreateTradeOrderItemUIFail("̎w肪܂");
                    return null;
                }
                bool new_or_close_required = (stock!=null && stock.Profile.IsDerivative)? true : !_dealTypeGenbutsu.Checked;
                if(new_or_close_required && !_newPositionButton.Checked && !_closePositionButton.Checked) {
                    if(show_messagebox) CreateTradeOrderItemUIFail("VK/ԍς̎w肪܂");
                    return null;
                }
                bool d = stock!=null && stock.Profile.IsDerivative;
                if(!d && _dealTypeGenbutsu.Checked) {
                    item.DealType = OrderDealType.Genbutsu;
                    item.LongShort = LongShort.Long;
                    item.NewOrClose = _buyButton.Checked? OrderNewClose.New : OrderNewClose.Close;
                }
                else {
                    item.DealType = d? OrderDealType.Derivatives : _dealTypeSeido.Checked? OrderDealType.CreditSeido : OrderDealType.CreditIppan;
                    item.LongShort = _buyButton.Checked ^ _closePositionButton.Checked? LongShort.Long : LongShort.Short;
                    item.NewOrClose = _newPositionButton.Checked? OrderNewClose.New : OrderNewClose.Close;
                }


                item.Kouza = _kouzaBox.SelectedIndex==0? OrderKouza.Tokutei : OrderKouza.Ippan;
                item.LimitDate = _dateBox.SelectedIndex==0? OrderLimitDate.Today : OrderLimitDate.Week;
                item.Volume = _volumeBox.GetTextAsInt();
            }
            else if(_parameter.OrderCategory==OrderFormParameter.Category.ClosePosition) {
                item = new TradeOrderItem(stock);
                item.OrderStatus = OrderStatus.Ordered;
                item.MarketAsText = stock==null? null : new string[] { formatter.FormatStockExchange(stock.Market) };
                item.NewOrClose = OrderNewClose.Close;
                item.LongShort = _parameter.CurrentPosition.LongShort;
                item.DealType = _parameter.CurrentPosition.DealType;
                item.Kouza = _parameter.CurrentPosition.OrderKouza;
                item.LimitDate = _dateBox.SelectedIndex==0? OrderLimitDate.Today : OrderLimitDate.Week;
                item.Volume = _volumeBox.GetTextAsInt();
                item.TargetPosition = _parameter.CurrentPosition;

                if(item.DealType!=OrderDealType.Genbutsu) { //MpE敨
                    if(_parameter.CloseType==OrderFormParameter.ClosePositionType.MultiplePosition) //|WVN[Y
                        item.ClosePositionDetail = CreatePositionAndVolumeList();
                    else {
                        //P|WV
                        Debug.Assert(_parameter.PositionElement!=null);
                        item.TargetPositionElement = _parameter.PositionElement;
                    }
                }
                else
                    item.TargetPositionElement = _parameter.PositionElement;


            }
            else { //Change 
                item = _parameter.CurrentOrder.Clone();
                item.OrderStatus = OrderStatus.Changed;
            }

            item.Condition = SikkoBoxIndexToOrderCondition(_sikkoBox.SelectedIndex, _nariyukiButton.Checked);
            if(OrderingUtil.IsSashineRequired(item.Condition)) {
                if(!_sashineBox.Enabled) {
                    if(show_messagebox ) CreateTradeOrderItemUIFail("wl̓͂Kvł");
                    return null;
                }
                else {
                    int sashine = _sashineBox.GetTextAsInt();
                    if(stock!=null && stock.Profile.IsDerivative) sashine *= 100; //敨wlC
                    item.Sashine = sashine;
                }
            }

            DateTime now = DateTime.Now;
            item.OrderDate = new BDate(BDate.DateTimeToInt(now));
            item.OrderTime = new BTime(now.Hour, now.Minute, 0);
            item.TransactionStatus = OrderTransactionStatus.Stable;

            return item;
        }
        private void CreateTradeOrderItemUIFail(string message) {
            BUtil.ShowWarningMessageBox(message);
            /*
            _orderButton.ClearMouseEnterState();
            _reserveButton.ClearMouseEnterState();
            */
        }

        //MBtrueԂ
        public bool SendOrderUI() {
            try {
                TradeOrderItem item = CreateTradeOrderItemUI();
                if(item==null) return false;

                if(!_omitConfirmDialogBox.Checked) {
                    OrderConfirmDialog dlg = new OrderConfirmDialog("mF", item, false, _parameter.OrderCategory==OrderFormParameter.Category.Change? "ύX" : "");
                    //if(BellagioRoot.FixedPreferences.Ordering.OrderFormStyle==OrderFormStyle.TopMost) dlg.TopMost = true;
                    DialogResult r = dlg.ShowDialog(this.ParentForm);
                    dlg.Dispose();
                    if(r!=DialogResult.OK) return false;
                }
                BellagioRoot.FixedPreferences.Ordering.ShowOrderConfirmDialog = !_omitConfirmDialogBox.Checked;
                BellagioRoot.FixedPreferences.AutoPinCode = _savePinCodeBox.Checked;

                //ۗɑ΂Ċm肵̒j
                if(_parameter.CurrentOrder!=null && _parameter.CurrentOrder.OrderStatus==OrderStatus.Preparing) {
                    BellagioRoot.OrderDataProvider.RemoveReservedOrder(_parameter.CurrentOrder);
                }

                if(_parameter.OrderCategory==OrderFormParameter.Category.Change)
                    BellagioRoot.OrderDataProvider.SendChangeOrder(item, _pinCodeBox.Text);
                else if(_parameter.OrderCategory==OrderFormParameter.Category.ClosePosition && item.DealType!=OrderDealType.Genbutsu)
                    BellagioRoot.OrderDataProvider.SendSpecifiedElementCloseOrder(item, _pinCodeBox.Text);
                else //VK܂̓|WVwȂ̕ԍ
                    BellagioRoot.OrderDataProvider.SendNewOrCloseOrder(item, _pinCodeBox.Text);

                return true;
            }
            catch(IllegalOrderException ex) {
                BUtil.ShowWarningMessageBox(ex.Message);
                return false;
            }
            catch(BellagioException ex) {
                RuntimeUtil.ReportException(ex);
                return false;
            }
            catch(Exception ex) {
                RuntimeUtil.ReportException(ex);
                return false;
            }
        }
        public bool ReserveOrderUI() {
            TradeOrderItem item = CreateTradeOrderItemUI();
            if(item!=null) {
                BellagioRoot.FixedPreferences.Ordering.ShowOrderConfirmDialog = !_omitConfirmDialogBox.Checked;

                item.OrderStatus = OrderStatus.Preparing;
                item.TransactionStatus = OrderTransactionStatus.Stable;
                BellagioRoot.OrderDataProvider.AddReservedOrder(item);
                if(Control.ModifierKeys!=Keys.Control) //CtrlȂ炾ƉBȂBpĕۗ
                    return true;
            }

            return false;
        }

        public void PerformNariyukiClick() {
            if(_nariyukiButton.Enabled) _nariyukiButton.Checked = !_nariyukiButton.Checked;// this.OnNariyukiButtonClick(_nariyukiButton, null);
        }

        private static int GetInitialSashinePrice(Stock stock) {
            IntraDayTrade dt = BellagioRoot.IntraDayTradeProvider.Lookup(stock);
            return dt==null? 1 : dt.CurrentPriceInfo.LastClose.Value;
        }
        private static int GetZeroDigitsCountFromVolumeUnit(int unit) {
            Debug.Assert(unit > 0);
            int zero = 0;
            while((unit % 10)==0) {
                zero++;
                unit /= 10;
            }
            return zero;
        }
        private static Bitmap LargeBitmap(int index) {
            return OrderingPlugin.OrderingIcons.GetBitmap(index);
        }

        public void InitToolTipText(ToolTip tt) {
            //tt.SetToolTip(_currentPriceButton, "ݒl(Ԓ)܂͊l(ԊO)wlɓ - V[gJbg F5");
            tt.SetToolTip(_nariyukiButton, "V[gJbg F4");
            //tt.SetToolTip(_maxVolumeButton, "݂̎wl̒lƗ]͏񂩂vZő\ʂ - V[gJbg F10");
        }


    }

    public class HoveringLabel : Label {
        private Image _normal;
        private Image _hovering;
        public HoveringLabel(Image normal, Image hovering) {
            this.BorderStyle = BorderStyle.None;
            this.Size = normal.Size;
            this.Image = normal;
            _normal = normal;
            _hovering = hovering;
        }
        public void SetImages(Image normal, Image hovering) {
            this.Image = normal;
            _normal = normal;
            _hovering = hovering;
        }
        protected override void OnMouseEnter(EventArgs e) {
            base.OnMouseEnter(e);
            this.Image = _hovering;
            this.Cursor = Cursors.Hand;
        }
        protected override void OnMouseLeave(EventArgs e) {
            base.OnMouseLeave(e);
            this.Image = _normal;
            this.Cursor = Cursors.Default;
        }


    }
}
